# -*- coding: utf-8 -*-
import os
import sys
import glob

def system(cmd):
    print (sys.argv[0],":",cmd)
    v = os.system(cmd)
    if v != 0:
        #print('ERROR',sys.argv[0],':',cmd,':',v)
        print('ERROR',':',v)
        sys.exit(-1)
        
def build_preload():

    DIRNAME = "./data"
    OUT = "./data/preload.js"

    out = open(OUT,"w")

    def escape(v):
        v = v.replace("\\","\\\\")
        v = v.replace("\'","\\\'")
        v = v.replace("\"","\\\"")
        v = v.replace("\r","\\r")
        v = v.replace("\n","\\n")
        v = v.replace("\t","\\t")
        return "\""+v+"\""

    out.write("function preload_init(G) {\n")

    for fname in glob.glob(DIRNAME+"/*"):
        name = fname.split('/')[-1]
        if '.' not in name: continue
        if name[0] == '.': continue
        if '~' in name: continue
        ext = name.split('.')[-1]
        base = name.split('.')[0]
        
        if ext in ['png','jpg']:
            out.write("var img = G.images[\""+base+"\"] = new Image(); img.src = \"data/"+name+"\";\n")
        
        if ext in ['map','txt','fnt']:
            content = "".join(open(fname,"r").readlines())
            out.write("G.files[\""+name+"\"] = "+escape(content)+";\n")
            
        #if ext in ['mp3']: 
            #out.write("createjs.Sound.registerSound(\"data/"+base+".mp3|data/"+base+".ogg\",\""+base+"\");\n")
        if ext in ['mp3']:
            out.write("var sound = G.samples[\""+base+"\"] = new Audio(\"data/"+base+"\"+_audioExt()); sound.load();\n")
        
    out.write("}\n");
    
def build_script():
    FILES = {}
    DIRNAME = "./data"
    OUT = "./data/script.txt"
    JS = "./data/script.js"

    def load(name):
        out.write("\n-- "+name+"\n")
        f = open(DIRNAME + "/" + name + ".lua","r")
        for line in f.readlines():
            if "JS:SKIP" in line: continue
            if "require(" in line:
                parts = line.replace("'",'"').split('"')
                load(parts[1])
                out.write("\n-- "+name+"\n")
            else:
                out.write(line)
        out.write("\n")

    out = open(OUT,"w")
    load("main")
    out.close()
    #system("./luajs/lua2js "+OUT+" "+JS);
    #system("./lua.js-master/lua2js "+OUT+" "+JS);
    system("./lua2js-phil "+OUT+" "+JS);
    content = "".join(open(JS,"r").readlines())
    content = content.replace("})()[0];","});")
    content = content.replace("var lua_script =","var lua_script_load =")
    f = open(JS,"w")
    f.write(content)
    f.close();

    
def build_audio():
    DIRNAME = "./data"
    for fname in glob.glob(DIRNAME+"/*"):
        name = fname.split('/')[-1]
        if '.' not in name: continue
        if name[0] == '.': continue
        if '~' in name: continue
        ext = name.split('.')[-1]
        base = name.split('.')[0]
        
        if ext in ['ogg']:
            system("oggdec "+fname+" -o ./tmp.wav");
            system("lame tmp.wav ./data/"+base+".mp3");
            system("rm -f ./tmp.wav");
        
        if ext in ['wav']:
            system("oggenc "+fname+" -o ./data/"+base+".ogg");
            system("lame "+fname+" ./data/"+base+".mp3");
        
def main():
    system("rm -rf ./data")
    system("mkdir ./data")
    system("cp ../data/turkey/* ./data")
    system("rm -f ./data/*~")
    
    build_script();
    build_audio();
    build_preload();
    
    system("rm -f ./data/*.lua")
    system("rm -f ./data/*.map")
    #system("rm -f ./data/*.txt")
    system("rm -f ./data/*.fnt")
    system("rm -f ./data/*.GlyphProject")
    system("rm -f ./data/*.wav")
    #system("rm -f ./data/*.ogg")

main()